<AdvancedModal>
  <div class="create-channel-modal">
    <h1>Create a Channel</h1>
    <TextInput name="Channel Name" value="" bind:value=channelName />
    <div class="media-switch">
      <Switch bind:media {media} />
      <span class="switch-value">Media Channel</span>
    </div>
    <Button {disabled} on:click="create($guildId, channelName, media)" text="Create" />
  </div>
</AdvancedModal>

<script>
  import AdvancedModal from "./AdvancedModal.svelte";
  import Button from "../forms/Button.svelte";
  import TextInput from "../forms/TextInput.svelte";
  import RestClient from "../../js/RestClient";
  import ChannelStore from "../../stores/ChannelStore";

  export default {
    components: {
      AdvancedModal,
      Button,
      TextInput,
      Switch: "../forms/Switch.svelte"
    },
    methods: {
      async create(guildId, name, media) {
        this.set({disabled: true});
        try {
          const res = await RestClient.put(`/guilds/${guildId}/channels`, {
            name,
            media
          });
          ChannelStore.slurp(res);
          this.store.setChannel(res.id);
          this.store.set({modal: null});
        } catch (err) {
          console.error(err);
          this.set({disabled: false});
        }
      }
    },
    data() {
      return {
        media: false
      };
    }
  };
</script>
